<?php

class Users extends CI_Controller {

	/**
	 * Index Page for this controller.
	 *
	 * Maps to the following URL
	 * 		http://example.com/index.php/welcome
	 *	- or -
	 * 		http://example.com/index.php/welcome/index
	 *	- or -
	 * Since this controller is set as the default controller in
	 * config/routes.php, it's displayed at http://example.com/
	 *
	 * So any other public methods not prefixed with an underscore will
	 * map to /index.php/welcome/<method_name>
	 * @see https://codeigniter.com/user_guide/general/urls.html
	 */
	public function index()
	{
		$this->load->view('index');
	}
    public function create()
	{
		$this->load->view('users/create');
	}
    public function register()
    {
        if($this->session->userdata("logged")){
        redirect(base_url().'categories');
        } 
        $this->form_validation->set_rules('nom','Nom','required|trim|min_length[3]');
        $this->form_validation->set_rules('email','Email','required|trim|valid_email|is_unique[users.email]');
        $this->form_validation->set_rules('passe','Mot de passe','required|trim|min_length[3]');
            if($this->form_validation->run() == FALSE){
                $data = array(
                'requires' => validation_errors()
                );
                $this->session->set_flashdata($data);
                $this->load->view('users/create',$data);
            }else{
                if($this->User->register_user()){
                    $this->session->set_flashdata('registred','Compte créé avec succés');
                    redirect(base_url().'home');
                }
            }
	}
    public function login()
	{
		$this->load->view('users/login');
	}
    public function auth(){
        if($this->session->userdata("logged")){
           redirect(base_url().'home');
        } 
        $this->form_validation->set_rules('email','Email','required|trim|valid_email');
        $this->form_validation->set_rules('passe','Mot de passe','required|trim|min_length[3]');
        if($this->form_validation->run() == FALSE){
            $data = array(
             'errors' => validation_errors()
            );
            $this->session->set_flashdata($data);
            $this->load->view('users/login',$data);
        }else {
            $email = $this->input->post('email');
            $password = $this->input->post('passe');
            $user = $this->User->login_user($email,$password);
            if($user == 'password_incorrect'){
                $this->session->set_flashdata('login_failed','L\'email ou le mot de passe est incorrect.');
                redirect(base_url()."users/login");
            }elseif($user == 'email_incorrect'){
                $this->session->set_flashdata('login_failed','L\'email ou le mot de passe est incorrect.');
                redirect(base_url()."users/login");
            }else{
                $user_data = array(
                    'nom'=> $user->nom,
                    'logged' => true
                );
                $this->session->set_userdata($user_data);
                redirect(base_url().'home');
            }   
        }
    }
    public function logout(){
        $this->session->unset_userdata('nom');
        $this->session->unset_userdata('logged');
        redirect(base_url().'home');
    }
}
